

// Sorry...

/*! Copyright (c) 2011 Brandon Aaron (http://brandonaaron.net)
 * Licensed under the MIT License (LICENSE.txt).
 *
 * Thanks to: http://adomas.org/javascript-mouse-wheel/ for some pointers.
 * Thanks to: Mathias Bank(http://www.mathias-bank.de) for a scope bug fix.
 * Thanks to: Seamus Leahy for adding deltaX and deltaY
 *
 * Version: 3.0.6
 * 
 * Requires: 1.2.2+
 */

(function($) {

var types = ['DOMMouseScroll', 'mousewheel'];

if ($.event.fixHooks) {
    for ( var i=types.length; i; ) {
        $.event.fixHooks[ types[--i] ] = $.event.mouseHooks;
    }
}

$.event.special.mousewheel = {
    setup: function() {
        if ( this.addEventListener ) {
            for ( var i=types.length; i; ) {
                this.addEventListener( types[--i], handler, false );
            }
        } else {
            this.onmousewheel = handler;
        }
    },
    
    teardown: function() {
        if ( this.removeEventListener ) {
            for ( var i=types.length; i; ) {
                this.removeEventListener( types[--i], handler, false );
            }
        } else {
            this.onmousewheel = null;
        }
    }
};

$.fn.extend({
    mousewheel: function(fn) {
        return fn ? this.bind("mousewheel", fn) : this.trigger("mousewheel");
    },
    
    unmousewheel: function(fn) {
        return this.unbind("mousewheel", fn);
    }
});


function handler(event) {
    var orgEvent = event || window.event, args = [].slice.call( arguments, 1 ), delta = 0, returnValue = true, deltaX = 0, deltaY = 0;
    event = $.event.fix(orgEvent);
    event.type = "mousewheel";
    
    // Old school scrollwheel delta
    if ( orgEvent.wheelDelta ) { delta = orgEvent.wheelDelta/120; }
    if ( orgEvent.detail     ) { delta = -orgEvent.detail/3; }
    
    // New school multidimensional scroll (touchpads) deltas
    deltaY = delta;
    
    // Gecko
    if ( orgEvent.axis !== undefined && orgEvent.axis === orgEvent.HORIZONTAL_AXIS ) {
        deltaY = 0;
        deltaX = -1*delta;
    }
    
    // Webkit
    if ( orgEvent.wheelDeltaY !== undefined ) { deltaY = orgEvent.wheelDeltaY/120; }
    if ( orgEvent.wheelDeltaX !== undefined ) { deltaX = -1*orgEvent.wheelDeltaX/120; }
    
    // Add event and delta to the front of the arguments
    args.unshift(event, delta, deltaX, deltaY);
    
    return ($.event.dispatch || $.event.handle).apply(this, args);
}

})(jQuery);




/**
 * @file
 * JS Implementation of OpenLayers behavior.
 */
(function($) {

/**
 * Zoom Layer Changer
 */
Drupal.openlayers.addBehavior('zmaps_zoom_layer_changer', function (data, options) {
  var olMap = data.openlayers;

  // Function to change base layer
  changeBase = function(event, timeout) {
    timeout = parseInt(timeout) || 500;
  
    // Yay, more hacks.  We have to wait a moment
    // as this often gets fired before the map
    // updates its zoom level.
    var t = setTimeout(function() {
      var zoom = olMap.getZoom();
      var center = olMap.getCenter();
      
      if (typeof options.zooms[olMap.zoom] != 'undefined') {
        var layers = olMap.getLayersBy('drupalID', options.zooms[olMap.zoom]);
  
        if (typeof layers[0] != 'undefined' && layers[0] != olMap.baseLayer) {
          olMap.setBaseLayer(layers[0]);
          olMap.setCenter(center, zoom);
        }
      }
    }, timeout);
  };

  // We utilize jQuery events :(.  Unfortunately
  // setting the base layer calls a re-center which would call
  // a zoomend again (infinite loop), so we cant use that and
  // there is no real other way, as the OL library doesn't
  // seem to allow for events like mousewheel.
  //
  // Also add custom event for those edge cases.
  $(olMap.div).bind({
    mousewheel: changeBase,
    dblclick: changeBase,
    click: changeBase,
    zmap_zoom_change: changeBase
  });
  $('.olControlZoomInItemInactive, ' + 
    '.olControlZoomToMaxExtentItemInactive, ' +
    '.olControlZoomOutItemInactive').bind({
    dblclick: changeBase,
    click: changeBase
  });
});

})(jQuery);